/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import jp.mosp.common.CommonConst;
import jp.mosp.common.action.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;

import jp.mosp.system.dao.MWorkTypeDao;
import jp.mosp.system.dto.MWorkTypeDto;

import jp.mosp.system.vo.WorkTypeMasterCardVo;

public class WorkTypeMasterCardAction extends MosPAction {

	// コマンド
	private static final String CMD_WORKTYPE_MASTER_CARD_SHOW   = "S2605";	// 表示(追加)
	private static final String CMD_WORKTYPE_MASTER_CARD_SELECT = "S2606";	// 表示(選択)
	private static final String CMD_WORKTYPE_MASTER_CARD_INSERT = "S2607";	// 登録
	private static final String CMD_WORKTYPE_MASTER_CARD_UPDATE = "S2608";	// 更新

	// フィールド
	private MWorkTypeDto dto;

	/**
	 * コンストラクタ
	 */
	public WorkTypeMasterCardAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		// VOの取得及び設定
		WorkTypeMasterCardVo vo = getInitVo();
		// 初期処理
		init(vo);
		// コマンド毎の処理
		if (cmd.equals(CMD_WORKTYPE_MASTER_CARD_SHOW)) {
			vo.setDefaultValues();
			vo.setMode(WorkTypeMasterCardVo.MODE_INSERT);
		} else if (cmd.equals(CMD_WORKTYPE_MASTER_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			select(vo);
		} else if (cmd.equals(CMD_WORKTYPE_MASTER_CARD_INSERT)) {
			// 新規登録
			insert(vo);
		} else if (cmd.equals(CMD_WORKTYPE_MASTER_CARD_UPDATE)) {
			// 更新
			update(vo);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * 初期VOインスタンス取得
	 * @return	初期VO
	 */
	protected WorkTypeMasterCardVo getInitVo() {
		return new WorkTypeMasterCardVo();
	}

	/**
	 * Action初期処理
	 * @param vo			対象VO
	 * @throws Exception
	 */
	protected void init(WorkTypeMasterCardVo vo) throws Exception {
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.setParams(request);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DTOの取得
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof MWorkTypeDto ? (MWorkTypeDto)obj : null;
		// 一日所定労働時間を取得
		vo.setLinitPerDay(Double.parseDouble(getMosPCode(CommonConst.TID_STATUTORY, CommonConst.TCD_STATUTORY_HOUR)[2]));
	}

	/**
	 * 選択
	 * @param vo			対象VO
	 * @throws Exception
	 */
	protected void select(WorkTypeMasterCardVo vo) throws Exception {
		// 表示(キーで情報を検索)
		// DAOの宣言
		MWorkTypeDao dao = new MWorkTypeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// データの取得
		dto = dao.findForKey(key1);
		chkExist(dto);
		// VOに情報をセット
		vo.setFields(dto);
		vo.setMode(WorkTypeMasterCardVo.MODE_UPDATE);
		// セッションにDTOをセット
		session.setAttribute(MospConst.ATT_DTO, dto);
	}

	/**
	 * データ挿入
	 * @param vo 対象VO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	protected void insert(WorkTypeMasterCardVo vo) throws Exception {
		vo.setPltDelete(String.valueOf(MospConst.DELETE_FLAG_OFF));
		// パラメータの妥当性確認
		vo.validate(true);
		// DAOの準備
		MWorkTypeDao dao = new MWorkTypeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 存在チェック
		chkDuplicate(dao.findForKey(vo.getTxtShiftCode()), vo);
		// DTOの準備
		MWorkTypeDto dto = new MWorkTypeDto();
		vo.setDtoFields(dto);
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		dto = dao.findForKey(dto.getShiftCode());
		// コミット
		commit();
		// モード設定
		vo.setMode(WorkTypeMasterCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_INSERT, ""));
		// セッションにDTOをセット
		session.setAttribute(MospConst.ATT_DTO, dto);
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	protected void update(WorkTypeMasterCardVo vo) throws Exception {
		// コード区分取得
		vo.setTxtShiftCode(dto.getShiftCode());
		// パラメータの妥当性確認
		vo.validate(false);
		// DAOの準備
		MWorkTypeDao dao = new MWorkTypeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(vo.getTxtShiftCode()), vo);
		// DTOの準備
		vo.setDtoFields(dto);
		// データの更新
		dao.update(dto);
		// DTOの再取得
		MWorkTypeDto retDto = dao.findForKey(dto.getShiftCode());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		vo.setMode(WorkTypeMasterCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		// セッションにDTOをセット
		session.setAttribute(MospConst.ATT_DTO, retDto);
	}

}
